
import React, { Component,useState } from 'react';
import { Card, Tree,Icon } from 'antd';
import { render } from 'preact';
import { turn } from 'cli-table';
const { DirectoryTree,TreeNode } = Tree;
const treeData = [
  {
    value:'江苏省公安厅',
    defaultValue:'0',
    parentKey:'0',
    isEditable:false,
    key:'0',
    children:[
      {
        value:'南京分局',
        key:'0-1',
        defaultValue: "0-1",
        isEditable: false,
      },
      {
        value:'苏州分局',
        key:'0-2',
        defaultValue: "0-2",
        isEditable: false,
      },
    ],
  },
];


const expandedKeyArr=['0'];


export default function TreeDemo() {
  const[data,setData]=useState(treeData)//获取值，及时更新被修改的值。变量
  const renderTreeNodes=(data)=>{
    let nodeArr=data.map((item)=>{//遍历数据
      item.title=(//修改
        <div style={{display:'flex', minWidth: '100px'}}>
          <span style={{ flex: 'auto' }}>{item.value}</span>
          <span style={{ width: '6em', flex: 'none',marginLeft:'20px' }}>
            {/* 编辑 */}
            <Icon type="edit" onClick={()=>onDelete(item.key)} /> 
            {/* 添加 */}
            <Icon type="diff" onClick={()=>onAdd(item.key)} />
            {/* 删除 */}
            <Icon type="delete"  onClick={()=>onEdit(item.key)}/>
          </span>
        </div>
      )
      if(item.children){//如果有子项就返回下面组件
        return(
          <TreeNode title={item.title} key={item.key} dataRef={item}>
            {renderTreeNodes(item.children)}
            {/* 重新渲染节点 */}
          </TreeNode>//title 接收的 ReactNode类型数据 自定义
        )
      }
      //返回
      return <TreeNode title={item.title} key={item.key} />
    })
      return nodeArr
  };
//添加
  const onAdd=(key)=>{
    // useState 里面数据是不能变的对象。需要slice返回一个新的数组
    addNode(key.treeData);//添加节点 树形
    setData(treeData.slice()) //设置 子项
  }
  //编辑
  const onEdit=(key)=>{
    editNode(key,treeData);
    setData(treeData.slice());
  };
  const editNode=(key,data)=>
    data.forEach((item)=>{
      if (item.key===key) {
        item.isEditable=true;//可编辑状态更改
      }else{
        item.isEditable=false;
      }
      item.value=item.defaultValue;//当某子项处于编辑状态，改变数据，点击其他时候，此项变成不可编辑
      if (item.children) {
        editNode(key,item.children);
      }
    })  

    //删除
    const onDelete = (key) => {
      deleteNode(key, treeData);
      setData(treeData.slice());
    };
    const deleteNode = (key, data) =>
      data.forEach((item, index) => {
        if (item.key === key) {
          data.splice(index, 1);//从某个位置开始删除元素
          return;
        } else {
          if (item.children) {
            deleteNode(key, item.children);
          }
        }
      });

  const addNode=(key,data)=>
    data.forEach((item)=>{
      if(item.key===key){//如果拿到的key相同则判断子项
        if (item.children) {
          item.children.push({
            value:"请输入内容",
            key:key+Math.random(100),//随机唯一的key
          });
        }
        return;
      }
      if (item.children) {
        addNode(key,item.children)//子项
      }
    })
  return (
    <div>
      <Card style={{width:'90%'}}>
        <Tree 
        switcherIcon={<Icon type="down-square" theme="filled" />}
        // icon={<Icon type="carry-out" />}
        style={{paddingLeft:'60px'}} 
        treeData={treeData}  >
        {renderTreeNodes(data)}
        </Tree>
        {/* 渲染被更新 */}
      </Card>
    </div>
  );
}





